package com.example.vaadintest;

import com.vaadin.annotations.Push;
import com.vaadin.annotations.Theme;
import com.vaadin.server.VaadinRequest;
import com.vaadin.ui.*;
import com.vaadin.ui.Button.ClickEvent;
import com.vaadin.ui.Button.ClickListener;
import com.vaadin.ui.Table.Align;

@SuppressWarnings("serial")
//@Theme("mytheme")
@Push
public class VaadintestUI extends UI {
  
  private EventHandler eh = new EventHandler();

	@Override
	protected void init(VaadinRequest request) {
    setTheme("mytheme");
	  
    Accordion accordion = new Accordion();
    accordion.setWidth(100, Unit.PERCENTAGE);
    accordion.setHeight(100, Unit.PERCENTAGE);
    
    fill(accordion);
    
    VerticalLayout hLayout = new VerticalLayout();
    
    hLayout.addComponent(accordion);
    
    hLayout.setHeight(100, Unit.PERCENTAGE);
    
    setContent(hLayout);
    
    setHeight(100,  Unit.PERCENTAGE);
	}

  /** Fills the accordion component with the open {@link ChangeSet}s.
   */
  private void fill(Accordion accordion) {
    accordion.removeAllComponents();
    Component lastTab = null;
    
    // for each open ChangeSet:
    for (int i = 0; i < 3; i++) {
      lastTab = addTab(accordion, i);
    }
    
//    if (selectedTabNo >= tabs.size() || selectedTabNo < 0) selectedTabNo = tabs.size() - 1;
    accordion.setSelectedTab(lastTab);
    accordion.setWidth(100, Unit.PERCENTAGE);

  }

  private VerticalLayout addTab(Accordion accordion, int number) {
    VerticalLayout layout = new VerticalLayout();

    Table table = createTable();
    TableButton btnSelect = new TableButton("Select", table);
    
    layout.addComponent(table);
    layout.addComponent(btnSelect);
    
    btnSelect.addClickListener(eh);

    accordion.addTab(layout, "Tab " + number);
    
    return layout;
  }


  private Table createTable() {
    ChangeSetFileTable tbl = new ChangeSetFileTable();
    
    tbl.fillFileTable();
    
    return tbl;
  }
    
  /** Event handler class.
   */
  private class EventHandler implements ClickListener {

    /** {@inheritDoc}
     */
    @Override
    public void buttonClick(ClickEvent event) {
      TableButton btn = (TableButton) event.getButton();
      
      btn.getTbl().select("1");
      System.out.println("button angeklickt");
    }
    
  }
}